Index: anr/anr.tex
===================================================================
--- anr/anr.tex	(revision 11)
+++ anr/anr.tex	(revision 12)
@@ -11,7 +11,19 @@
 \usepackage{graphicx}
 \usepackage{color}
-
-\definecolor{gris25}{gray}{0.75}
-\definecolor{gris75}{gray}{0.30}
+\usepackage{xspace}
+\usepackage{geometry}
+\geometry{verbose,a4paper,tmargin=3cm,bmargin=2cm,lmargin=2cm,rmargin=3cm}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\def\xcoach{\texttt{xcoach}\xspace}
+\def\backbone{backbone\xspace}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\def\anrdoc#1{}
+\let\pagefeed\relax
+\def\euro{\mbox{\raisebox{.25ex}{{\it =}}\hspace{-.5em}{\sf C}}}
+\definecolor{gris}{gray}{0.75}
+\definecolor{rouge}{rgb}{1.0,0.2,0.2}
+\def\mustbecompleted#1{}
 
 \title{%
@@ -21,9 +33,248 @@
 }
 
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% DEBUT CONFIG
+% Comment next marcro to suppress the printing of anr directives
+\def\anrdoc#1{\noindent\begin{scriptsize}\textcolor{red}{#1}\end{scriptsize}\ifhmode\par\fi}
+% Comment the next macro to suppress the pagefeed
+\let\pagefeed\newpage
+% Comment the next macro to suppress it
+\def\mustbecompleted#1{\textcolor{gris}{#1}}
+% FIN CONFIG
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \begin{document}
-\input{body.tex}
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% 1
+\section{Executive summary}
+\anrdoc{(2 pages maximum) Résumer la problématique que le projet propose
+de résoudre, et comment cet objectif sera poursuivi (quelle approche
+technique, etc.). \\
+Ce résumé devra démontrer l'originalité du projet notamment sur les points
+suivants:
+\begin{itemize}
+\item les objectifs globaux, les verrous scientifiques et techniques,
+\item le programme de travail,
+\item les retombées scientifiques, techniques et économiques.
+\end{itemize}
+Ces éléments peuvent être recopiés dans les champs «résumés scientifiques»
+du site de soumission.}
+\input{section-1}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% 2
+\pagefeed\section{Context and relevance to the call }
+\anrdoc{(1 page maximum) Présentation générale du problème qu'il est
+proposé de traiter dans le projet et du cadre de travail
+(recherche fondamentale, industrielle ou développement expérimental).}
+\input{section-2}
+
+% 2.1
+\pagefeed\subsection{Context, economic and societal issues}
+\anrdoc{(2 pages maximum) Décrire le contexte économique, social, réglementaire
+dans lequel se situe le projet en présentant une analyse des enjeux sociaux,
+économiques, environnementaux, industriels. Donner si possible des arguments
+chiffrés, par exemple, pertinence et portée du projet par rapport à la
+demande économique (analyse du marché, analyse des tendances), analyse
+de la concurrence, indicateurs de réduction de coûts, perspectives de
+marchés (champs d'application, ...). Indicateurs des gains environnementaux,
+cycle de vie.}
+\input{section-2.1}
+
+% 2.2
+\pagefeed\subsection{Relevance of the proposal}
+\anrdoc{(2 pages maximum) Préciser :\begin{itemize}
+\item positionnement du projet par rapport au contexte développé précédemment:
+  vis- à-vis des projets et recherches concurrents, complémentaires ou
+  antérieurs, des brevets et standards...
+\item positionnement du projet par rapport aux axes thématiques de l'appel
+  à projets.
+\item positionnement du projet aux niveaux européen et international.
+\end{itemize}}
+\input{section-2.2}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% 3
+\section{Scientific and technical Description}
+
+% 3.1
+\pagefeed\subsection{State of the Art}
+\anrdoc{(3 pages maximum) écrire le contexte et les enjeux scientifiques
+dans lequel se situe le projet en présentant un état de l'art national et
+international dressant l'état des connaissances sur le sujet. Faire
+apparaître d'éventuels résultats préliminaires. Inclure les références
+bibliographiques nécessaires en annexe 7.1.}
+\input{section-3.1}
+
+% 3.2
+\pagefeed\subsection{S \& T objectives, progress beyond the state of the art}
+\anrdoc{(2 pages maximum)
+Décrire les objectifs scientifiques/techniques du projet.\\
+Présenter l'avancée scientifique attendue. Préciser l'originalité et le
+caractère ambitieux du projet.\\
+Détailler les verrous scientifiques et techniques à lever par la
+réalisation du projet.\\
+Décrire éventuellement le ou les produits finaux développés à l'issue du
+projet  montrant le caractère innovant du projet.\\
+Présenter les résultats escomptés en proposant si possible des critères de
+réussite et d'évaluation adaptés au type de projet, permettant d'évaluer
+les résultats en fin de projet.\\
+Le cas échéant (programmes exigeant la pluridisciplinarité), démontrer
+l'articulation entre les disciplines scientifiques.}
+\input{section-3.2}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% 4
+\section{Scientific and technical objectives / project description}
+
+% 4.1
+\pagefeed\subsection{Scientific Programme, Project structure}
+\anrdoc{(2 pages maximum)
+Présentez le programme scientifique et justifiez la décomposition en tâches
+du programme de travail en cohérence avec les objectifs poursuivis.\\
+Utilisez un diagramme pour présenter les liens entre les différentes tâches
+(organigramme technique)\\
+Les tâches représentent les grandes phases du projet. Elles sont en nombre
+limité.\\
+N'oubliez pas les activités et actions correspondant à la dissémination et
+à la valorisation.}
+\input{section-4.1}
+
+% 4.2
+\pagefeed\subsection{Project management}
+\anrdoc{(2 pages maximum)
+Préciser les aspects organisationnels du projet et les modalités de
+coordination (si possible individualisation d'une tâche coordination : cf.
+tâche 0 du document de soumission A).}
+\input{section-4.2}
+
+% 4.3
+\pagefeed\subsection{Description of the tasks}
+\anrdoc{(idéalement 1 ou 2 pages par tâche)
+Pour chaque tâche, décrire:\begin{itemize}
+\item les objectifs  de la tâche et éventuels indicateurs de succès,
+\item le responsable de la tâche et les partenaires impliqués (possibilité
+de l'indiquer sous forme graphique),
+\item le programme détaillé des travaux par tâche,
+\item les livrables de la tâche,
+\item les contributions des partenaires (le «qui fait quoi»),
+\item la description des méthodes et des choix techniques et de la manière
+dont les solutions seront apportées,
+\item les risques de la tâche et les solutions de repli envisagées.
+\end{itemize}}
+
+\subsubsection{Task 1}
+%\input{task-0}
+
+\subsubsection{Task 2}
+\input{task-1}
+
+
+\subsection{Tasks schedule, deliverables and milestones}
+\anrdoc{(3 pages maximum)\begin{itemize}
+\item Présenter sous forme graphique un échéancier des différentes tâches
+et leurs dépendances (diagramme de Gantt par exemple).
+\item Présenter un tableau synthétique  de l'ensemble des livrables du
+projet (numéro de tâche, date, intitulé, responsable).
+\item Préciser de façon synthétique les jalons scientifiques et/ou
+techniques, les principaux points de rendez-vous, les points bloquants ou
+aléas qui risquent de remettre en cause l'aboutissement du projet ainsi que
+les réunions de projet prévues.\end{itemize}}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\section{Dissemination and exploitation of results.
+         Management of intellectual property}
+\anrdoc{(1 à 2 pages)\\
+Présenter les stratégies de valorisation des résultats :
+\begin{itemize}
+\item la communication scientifique;
+\item la communication auprès du grand public;
+\item la valorisation des résultats attendus;
+\item les retombées scientifiques, techniques, industrielles, économiques, 
+\item la place du projet dans la stratégie industrielle des entreprises partenaires du projet
+\item autres retombées (normalisation, information des pouvoirs publics, ...)
+\item les échéances et la nature des retombées technico- économiques attendues
+\item l'incidence éventuelle sur l'emploi, la création d'activités nouvelles.
+\end{itemize}
+Présenter les grandes lignes des modes de protection et d'exploitation des
+résultats\\
+Pour les projets partenariaux organismes de recherche/entreprises, les
+partenaires devront conclure, sous l'égide du coordinateur du projet, un
+accord de consortium dans un délai de un an si le projet est retenu pour
+financement.\\
+Pour les projets académiques, l'accord de consortium n'est pas obligatoire
+mais fortement conseillé.}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\section{Consortium Description}
+
+\subsection{Partners description \& relevance, complementarity}
+\anrdoc{(maximum 0,5 page par partenaire) Décrire brièvement chaque
+partenaire et fournir ici les éléments permettant d'apprécier la
+qualification des partenaires dans le projet (le « pourquoi qui fait quoi
+»). Il peut s'agir de réalisations passées, d'indicateurs (publications,
+brevets), de l'intérêt du partenaire pour le projet.\\
+Montrer la complémentarité et la valeur ajoutée des coopérations entre les
+différents partenaires. L'interdisciplinarité et l'ouverture à diverses
+collaborations seront à justifier en accord avec les orientations du
+projet. (1 page maximum)}
+
+\subsection{Relevant experience of the project coordinator}
+\anrdoc{(0,5 page maximum) Fournir les éléments permettant de juger la
+capacité du coordinateur à coordonner le projet.}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\section{Scientific justification for the mobilisation of the  resources}
+\anrdoc{On présentera ici la justification scientifique et technique des moyens
+demandés dans le document de soumission A par chaque partenaire et
+synthétisés à l'échelle du projet dans la fiche «Tableaux récapitulatifs»
+du document de soumission A.\\
+Chaque partenaire justifiera les moyens qu'il demande en distinguant les
+différents postes de dépenses.}
+
+\subsection{Partner 1: XXX}
+\anrdoc{\begin{itemize}
+\item Equipment: 1) Préciser la nature des équipements* et justifier le
+    choix des équipements. 2) Si nécessaire, préciser la part de financement
+    demandé sur le projet et si les achats envisagés doivent être complétés
+    par d'autres sources de financement. Si tel est le cas, indiquer le
+    montant et l'origine de ces financements complémentaires.
+    3) Attention: Un devis sera demandé si le projet est retenu pour
+    financement.
+\item Personnel costs
+    1) Le personnel non permanent (thèses, post- doctorants,CDD...)
+    financé sur le projet devra être justifié.
+    2) Fournir  les profils des postes à pourvoir pour les personnels à
+    recruter (1/2 page maximum par type de poste)
+    3) Pour les thèses, préciser si des demandes de bourse de thèse sont
+    prévues ou en cours, en préciser la nature et la part de financement
+    imputable au projet. 
+\item Subcontracting. Préciser: 1) la nature des prestations
+    2) le type de prestataire.
+\item Travel.  Préciser: 1) les missions liées aux travaux d'acquisition
+    sur le terrain (campagnes de mesures),
+    2) les missions relevant de colloques, congrès.
+\item Expenses for inward billing (Costs justified by internal procedures
+of invoicing). Préciser la nature des prestations
+\item Other working costs. Toute dépense significative relevant de ce poste
+devra être justifiée.
+\end{itemize}}
+
+\subsection{Partner 2: XXX}
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+\section{Annexes}
+%\subsection{References}
+\anrdoc{Inclure la liste des références bibliographiques utilisées dans la
+partie «Etat de l'art» et les références bibliographiques des
+partenaires ayant trait au projet.}
+\bibliographystyle{plain}
+\bibliography{anr}
+\newpage
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \end{document}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%