Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Parameters.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h"
 
 namespace morpheo {
@@ -12,5 +12,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
@@ -39,5 +39,5 @@
   { };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp	(revision 15)
@@ -6,6 +6,6 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Parameters.h"
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Types.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h"
 #include <sstream>
 using namespace std;
@@ -15,5 +15,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
   string Parameters::msg_error(void)
@@ -65,5 +65,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Parameters.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h"
 #include <sstream>
 using namespace std;
@@ -14,5 +14,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
   string Parameters::print (uint32_t depth)
@@ -20,10 +20,10 @@
     string tab = string(depth,'\t');
     ostringstream msg;
-    msg << tab << "<pseudo_lru>" << endl
+    msg << tab << "<victim_pseudo_lru>" << endl
 	<< tab << "\t<nb_entity  value=\"" << _nb_entity  << "\" />" << endl
 	<< tab << "\t<nb_access  value=\"" << _nb_access  << "\" />" << endl
 	<< tab << "\t<nb_update  value=\"" << _nb_update  << "\" />" << endl
 	<< tab << "\t<size_table value=\"" << _size_table << "\" />" << endl
-	<< tab << "</pseudo_lru>" << endl;
+	<< tab << "</victim_pseudo_lru>" << endl;
     
     return msg.str();
@@ -31,5 +31,5 @@
 
   ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::victim::pseudo_lru::Parameters & x)
+		       morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x)
   {
     output_stream << x.print(0);
@@ -38,5 +38,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Statistics.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
 
 namespace morpheo                    {
@@ -13,5 +13,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
@@ -38,5 +38,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_add.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_add.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Statistics.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
 
 #include <sstream>
@@ -16,5 +16,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
   void Statistics::add (uint32_t nb_access,
@@ -25,5 +25,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Statistics.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
 
 #include <sstream>
@@ -16,5 +16,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
@@ -24,7 +24,7 @@
     ostringstream msg;
 
-    msg << tab << "<pseudo_lru name=\"" << _name << "\" >" << endl
+    msg << tab << "<victim_pseudo_lru name=\"" << _name << "\" >" << endl
 	<< print_body (depth+1)
-	<< tab << "</pseudo_lru>" << endl;
+	<< tab << "</victim_pseudo_lru>" << endl;
     
     return msg.str();
@@ -32,5 +32,5 @@
 
   ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::victim::pseudo_lru::Statistics & x)
+		       morpheo::behavioural::generic::victim::victim_pseudo_lru::Statistics & x)
   {
     output_stream << x.print(0);
@@ -39,5 +39,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print_body.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print_body.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Statistics.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
 
 #include <sstream>
@@ -16,5 +16,5 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
@@ -30,5 +30,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -12,22 +12,22 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 #ifdef SYSTEMC
-  Pseudo_LRU::Pseudo_LRU (sc_module_name name,
+  Victim_Pseudo_LRU::Victim_Pseudo_LRU (sc_module_name name,
 #else
-  Pseudo_LRU::Pseudo_LRU (string name,
+  Victim_Pseudo_LRU::Victim_Pseudo_LRU (string name,
 #endif
 #ifdef STATISTICS
 			  morpheo::behavioural::Parameters_Statistics             param_statistics,
 #endif
-			  morpheo::behavioural::generic::victim::pseudo_lru::Parameters param ):
+			  morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters param ):
 			  _name   (name)
 			  ,_param (param)
   {
-    log_printf(FUNC,Pseudo_LRU,"Pseudo_LRU","Begin");
+    log_printf(FUNC,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Begin");
 
 #ifdef STATISTICS
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","Allocation of statistics");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Allocation of statistics");
     
     // Allocation of statistics
@@ -41,5 +41,5 @@
     //  -> port
     //  -> clock's signals
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","Creation of Testbench");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Creation of Testbench");
     _vhdl_testbench = new Vhdl_Testbench (_name);
     vhdl_testbench_port           (*_vhdl_testbench);
@@ -49,13 +49,13 @@
 #ifdef VHDL
     // generate the vhdl
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","Generation of VHDL");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Generation of VHDL");
     vhdl();
 #endif
 
 #ifdef SYSTEMC
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","Allocation");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Allocation");
     allocation ();
 
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","Definition of sc_method");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","Definition of sc_method");
     SC_METHOD (transition);
     dont_initialize ();
@@ -73,5 +73,5 @@
 
 #ifdef SYSTEMCASS_SPECIFIC
-    log_printf(TRACE,Pseudo_LRU,"Pseudo_LRU","List dependency information");
+    log_printf(TRACE,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","List dependency information");
     // List dependency information
     for (uint32_t i=0; i<_param._nb_access; i++)
@@ -90,10 +90,10 @@
 
 #endif
-    log_printf(FUNC,Pseudo_LRU,"Pseudo_LRU","End");
+    log_printf(FUNC,Victim_Pseudo_LRU,"Victim_Pseudo_LRU","End");
   };
   
-  Pseudo_LRU::~Pseudo_LRU (void)
+  Victim_Pseudo_LRU::~Victim_Pseudo_LRU (void)
   {
-    log_printf(FUNC,Pseudo_LRU,"~Pseudo_LRU","Begin");
+    log_printf(FUNC,Victim_Pseudo_LRU,"~Victim_Pseudo_LRU","Begin");
 #ifdef SYSTEMC
     deallocation ();
@@ -111,8 +111,8 @@
     delete _stat;
 #endif
-    log_printf(FUNC,Pseudo_LRU,"~Pseudo_LRU","End");
+    log_printf(FUNC,Victim_Pseudo_LRU,"~Victim_Pseudo_LRU","End");
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,9 +13,10 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
-  void Pseudo_LRU::allocation (void)
+  void Victim_Pseudo_LRU::allocation (void)
   {
     in_CLOCK  = new SC_CLOCK           ("in_CLOCK");
+    in_NRESET = new SC_IN (Tcontrol_t) ("in_NRESET");
 
     // -----[ Interface access ]-------------------------------------------
@@ -82,5 +83,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_deallocation.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo                    {
@@ -13,10 +13,10 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
-  void Pseudo_LRU::deallocation (void)
+  void Victim_Pseudo_LRU::deallocation (void)
   {
     delete in_CLOCK;
-
+    delete in_NRESET;
     // -----[ Interface access ]-------------------------------------------
     for (uint32_t i=0; i<_param._nb_access; i++)
@@ -61,5 +61,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_genMealy_access.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_genMealy_access.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_genMealy_access.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,7 +13,7 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
-  void Pseudo_LRU::genMealy_access (void)
+  void Victim_Pseudo_LRU::genMealy_access (void)
   {
     for (uint32_t i=0; i<_param._nb_access; i++)
@@ -39,5 +39,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo                    {
@@ -13,13 +13,13 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
   
-  string Pseudo_LRU::statistics (uint32_t depth)
+  string Victim_Pseudo_LRU::statistics (uint32_t depth)
   {
     return _stat->print(depth);
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,7 +13,7 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
-  void Pseudo_LRU::transition (void)
+  void Victim_Pseudo_LRU::transition (void)
   {
 #ifdef STATISTICS
@@ -71,5 +71,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 #include "Behavioural/include/Vhdl.h"
 
@@ -14,29 +14,29 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
-  void Pseudo_LRU::vhdl (void)
+  void Victim_Pseudo_LRU::vhdl (void)
   {
-    log_printf(FUNC,Pseudo_LRU,"vhdl","Begin");
+    log_printf(FUNC,Victim_Pseudo_LRU,"vhdl","Begin");
 
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Construction of vhdl");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Construction of vhdl");
     Vhdl vhdl (_name);
 
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Set library");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Set library");
     vhdl.set_library_work (_name + "_Pack");
 
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Set port");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Set port");
     vhdl_port        (vhdl);
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Set declaration");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Set declaration");
     vhdl_declaration (vhdl);
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Set body");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Set body");
     vhdl_body        (vhdl);
-    log_printf(TRACE,Pseudo_LRU,"vhdl","Generate File");
+    log_printf(TRACE,Victim_Pseudo_LRU,"vhdl","Generate File");
     vhdl.generate_file();
-    log_printf(FUNC,Pseudo_LRU,"vhdl","End");
+    log_printf(FUNC,Victim_Pseudo_LRU,"vhdl","End");
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,7 +13,7 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
-
-  void Pseudo_LRU::vhdl_body (Vhdl & vhdl)
+namespace victim_pseudo_lru {
+
+  void Victim_Pseudo_LRU::vhdl_body (Vhdl & vhdl)
   {
     vhdl.set_body ("");
@@ -219,5 +219,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_declaration.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_declaration.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,8 +13,8 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
-  void Pseudo_LRU::vhdl_declaration (Vhdl & vhdl)
+  void Victim_Pseudo_LRU::vhdl_declaration (Vhdl & vhdl)
   {
     vhdl.set_type ("Ttable", "array (" + toString(_param._size_table-1) + " downto 0) of "+std_logic(_param._nb_entity-1));
@@ -35,5 +35,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_port.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_port.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_port.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo                    {
@@ -13,10 +13,11 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
-  void Pseudo_LRU::vhdl_port (Vhdl & vhdl)
+  void Victim_Pseudo_LRU::vhdl_port (Vhdl & vhdl)
   {
-    vhdl.set_port ("in_CLOCK" , IN, "std_logic");
+    vhdl.set_port ("in_CLOCK ", IN, 1);
+    vhdl.set_port ("in_NRESET", IN, 1);
 
     for (uint32_t i = 0; i < _param._nb_access; i ++)
@@ -39,5 +40,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_port.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_port.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_port.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo                    {
@@ -13,9 +13,10 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
-  void Pseudo_LRU::vhdl_testbench_port (Vhdl_Testbench & vhdl_testbench)
+  void Victim_Pseudo_LRU::vhdl_testbench_port (Vhdl_Testbench & vhdl_testbench)
   {
+    vhdl_testbench.set_port (" in_NRESET",IN ,1);
     for (uint32_t i = 0; i < _param._nb_access; i ++)
       {
@@ -37,5 +38,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_transition.cpp	(revision 10)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_transition.cpp	(revision 15)
@@ -7,5 +7,5 @@
  */
 
-#include "Behavioural/Generic/Victim/Pseudo_LRU/include/Pseudo_LRU.h"
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
 
 namespace morpheo {
@@ -13,12 +13,13 @@
 namespace generic {
 namespace victim {
-namespace pseudo_lru {
+namespace victim_pseudo_lru {
 
 
-  void Pseudo_LRU::vhdl_testbench_transition (Vhdl_Testbench & vhdl_testbench)
+  void Victim_Pseudo_LRU::vhdl_testbench_transition (Vhdl_Testbench & vhdl_testbench)
   {
 #ifndef SYSTEMCASS_SPECIFIC
     sc_cycle(0);
 #endif
+    vhdl_testbench.add_input  (PORT_READ(in_NRESET));
 
     for (uint32_t i = 0; i < _param._nb_access; i ++)
@@ -45,5 +46,5 @@
   };
 
-}; // end namespace pseudo_lru
+}; // end namespace victim_pseudo_lru
 }; // end namespace victim
 }; // end namespace generic